function ButtonTrackingObj(exp, titleName, cm, frame){
   this.VarTrivBtnTracking = new Variable( 'VarTrivBtnTracking', null, 0, cm, frame, exp, titleName, true );
   this.title = null;
}

ButtonTrackingObj.codeToStateMap =
{
	'N' : 'normalState',
	'O' : 'overState',
	'D' : 'downState',
	'A' : 'disabledState',
	'V' : 'visitedState',
	'S' : 'selectedState'
};
ButtonTrackingObj.stateToCodeMap = {};
for (var key in ButtonTrackingObj.codeToStateMap)
	ButtonTrackingObj.stateToCodeMap[ButtonTrackingObj.codeToStateMap[key]] = key;

ButtonTrackingObj.prototype.InitPageTracking = function ( )
{
	var THIS = this;
	var pageTrackData = this.VarTrivBtnTracking.getValue();
	var bDoInit = true;
	try {
	    if (pageTrackData && pageTrackData.length > 0 && pageTrackData != '~~~null~~~')
	    {
	        var topLevelSplit = pageTrackData.split('#');
	        if (topLevelSplit && topLevelSplit.length > 1)
            {
		        var arrIds = topLevelSplit[0].split(',');
		        var arrStatus = topLevelSplit[1].split(',');
		        for( var i=0; i<arrIds.length; i++ )
		        {
			        var id = parseInt( '0x' + arrIds[i] );
			        var status = arrStatus[i];
			        var node = this.FindNode( this.title, id );
			        if( node )
						node.v = ButtonTrackingObj.codeToStateMap[status] || status;
		        }
    		}
        }
    } catch (e) { }
}

ButtonTrackingObj.prototype.FindNode = function( node, id )
{
	if( node.id == id )
		return node;
	
	var match = null;
	if( typeof( node.c ) != 'undefined' ){
		for( var i=0; i<node.c.length; i++ ){
			match = this.FindNode( node.c[i], id );
			if( match != null )
				break;
		}
	}
	
	return match;
}

ButtonTrackingObj.prototype.InternalGetRangeStatus = function( node )
{
	if( node == null )
		return -1;
		
	if( typeof(node.c) == 'undefined' )
	{
		return node.v;
	}
	else
	{
		return 'normalState';
	}
}


ButtonTrackingObj.prototype.GetRangeStatus = function( id, bInit )
{
	var status = -1;
	if ( bInit ) 
		this.InitPageTracking();
	
	status = this.InternalGetRangeStatus( this.FindNode( this.title, id ) );

	return status;
}


ButtonTrackingObj.prototype.InternalSetRangeStatus=function( node, status )
{
	if( node == null )
		return;
	node.v = status;
	if( status == 0 && typeof(node.c)!='undefined')
	{
		for( var i=0; i<node.c.length; i++ )
			this.InternalSetRangeStatus( node.c[i], status ); 
	}
}

ButtonTrackingObj.prototype.SetRangeStatus = function( id, status /*0 or 1 or 2*/)
{
	this.InternalSetRangeStatus( this.FindNode(this.title, id), status );
	
	this.SavePageTracking();
}

ButtonTrackingObj.prototype.IterateTree = function( func )
{
	var stack = [];
	stack.push( this.title );
	var i = 0;
	while( stack.length > 0 )
	{
		var node = stack.shift();
		
		if( typeof(node.c) != 'undefined' )
			stack = node.c.concat(stack);
			
		//do the thing
		func( node, i, stack );
		i++;
	}	
}

ButtonTrackingObj.prototype.SavePageTracking = function()
{
	var fnIsSaveState = window.ObjButton && ObjButton.isSaveState || function () { return false; };
	var hexString = '';
	var arrayIds = [];
	var arrayStatus= [];
	
	this.IterateTree(function(node, i, stack){
		if (fnIsSaveState(node.v))
		{
			arrayIds.push(node.id);
			arrayStatus.push(node.v);
		}
	});
	
	for( var i=0; i<arrayIds.length; i++ )
		hexString += (i > 0 ? ',' : '') + arrayIds[i].toString(16);

	hexString += (arrayIds.length > 0 ? '#' : '');
	
	for (var i = 0; i < arrayStatus.length; i++)
		hexString += (i > 0 ? ',' : '') + (ButtonTrackingObj.stateToCodeMap[arrayStatus[i]] || arrayStatus[i]);
	
	this.VarTrivBtnTracking.set(hexString);
}

var trivBtnTracking = new ButtonTrackingObj(365,'making_money_in_technology_media_and_telecom', 0, 'scorm');
trivBtnTracking.title={id:1,v:0,c:[{id:149834,v:'normalState'},{id:51478,v:'normalState'},{id:48393,v:'normalState'},{id:74925,v:'normalState'},{id:79661,v:'normalState'},{id:58823,v:'normalState'},{id:67568,v:'normalState'},{id:124474,v:'normalState'},{id:197221,v:'normalState'},{id:197485,v:'normalState'},{id:322441,v:'normalState'},{id:166805,v:'normalState'},{id:192971,v:'normalState'},{id:192979,v:'normalState'},{id:192987,v:'normalState'},{id:208474,v:'normalState'},{id:193013,v:'normalState'},{id:152642,v:'normalState'},{id:321209,v:'normalState'},{id:583881,v:'normalState'},{id:719246,v:'normalState'},{id:672862,v:'normalState'},{id:588267,v:'normalState'},{id:588287,v:'normalState'},{id:588297,v:'normalState'},{id:588654,v:'normalState'},{id:588927,v:'normalState'},{id:588316,v:'normalState'},{id:589833,v:'normalState'},{id:589843,v:'normalState'},{id:589857,v:'normalState'},{id:589867,v:'normalState'},{id:589874,v:'normalState'},{id:588340,v:'normalState'},{id:588350,v:'normalState'},{id:589622,v:'normalState'},{id:589675,v:'normalState'},{id:588369,v:'normalState'},{id:673648,v:'normalState'},{id:673658,v:'normalState'},{id:673670,v:'normalState'},{id:673678,v:'normalState'},{id:673685,v:'normalState'},{id:676727,v:'normalState'},{id:676737,v:'normalState'},{id:676749,v:'normalState'},{id:676757,v:'normalState'},{id:676764,v:'normalState'},{id:673768,v:'normalState'},{id:673778,v:'normalState'},{id:673792,v:'normalState'},{id:673802,v:'normalState'},{id:673809,v:'normalState'},{id:677026,v:'normalState'},{id:677033,v:'normalState'},{id:677040,v:'normalState'},{id:677047,v:'normalState'},{id:677054,v:'normalState'},{id:677062,v:'normalState'},{id:617460,v:'normalState'},{id:617471,v:'normalState'},{id:617483,v:'normalState'},{id:617494,v:'normalState'},{id:617505,v:'normalState'},{id:679506,v:'normalState'},{id:698681,v:'normalState'},{id:699003,v:'normalState'},{id:699262,v:'normalState'},{id:699752,v:'normalState'},{id:700097,v:'normalState'},{id:700442,v:'normalState'},{id:617602,v:'normalState'},{id:594176,v:'normalState'},{id:594348,v:'normalState'},{id:591213,v:'normalState'},{id:591222,v:'normalState'},{id:591230,v:'normalState'},{id:610365,v:'normalState'},{id:610392,v:'normalState'},{id:583793,v:'normalState'},{id:684040,v:'normalState'},{id:683872,v:'normalState'},{id:583038,v:'normalState'},{id:723447,v:'normalState'},{id:723457,v:'normalState'},{id:723467,v:'normalState'},{id:723422,v:'normalState'},{id:723430,v:'normalState'},{id:723438,v:'normalState'},{id:611506,v:'normalState'},{id:593418,v:'normalState'},{id:617035,v:'normalState'},{id:593668,v:'normalState'},{id:594006,v:'normalState'},{id:586708,v:'normalState'},{id:586726,v:'normalState'},{id:586744,v:'normalState'},{id:586762,v:'normalState'},{id:586780,v:'normalState'},{id:689625,v:'normalState'},{id:583388,v:'normalState'},{id:583399,v:'normalState'},{id:583410,v:'normalState'},{id:583421,v:'normalState'},{id:583438,v:'normalState'},{id:583447,v:'normalState'},{id:690447,v:'normalState'},{id:690288,v:'normalState'},{id:690694,v:'normalState'},{id:690701,v:'normalState'},{id:701601,v:'normalState'},{id:701608,v:'normalState'},{id:703284,v:'normalState'},{id:703294,v:'normalState'},{id:703304,v:'normalState'},{id:703314,v:'normalState'},{id:703324,v:'normalState'},{id:701680,v:'normalState'},{id:704527,v:'normalState'},{id:701703,v:'normalState'},{id:704165,v:'normalState'},{id:701721,v:'normalState'},{id:704712,v:'normalState'},{id:701739,v:'normalState'},{id:701750,v:'normalState'},{id:705066,v:'normalState'},{id:705073,v:'normalState'},{id:705090,v:'normalState'},{id:705100,v:'normalState'},{id:705110,v:'normalState'},{id:705120,v:'normalState'},{id:705130,v:'normalState'},{id:705145,v:'normalState'},{id:705163,v:'normalState'},{id:705168,v:'normalState'},{id:706901,v:'normalState'},{id:706895,v:'normalState'},{id:707038,v:'normalState'},{id:707032,v:'normalState'},{id:705215,v:'normalState'},{id:707597,v:'normalState'},{id:707604,v:'normalState'},{id:707621,v:'normalState'},{id:707631,v:'normalState'},{id:707641,v:'normalState'},{id:707651,v:'normalState'},{id:707661,v:'normalState'},{id:707676,v:'normalState'},{id:708093,v:'normalState'},{id:708087,v:'normalState'},{id:708373,v:'normalState'},{id:708367,v:'normalState'},{id:708525,v:'normalState'},{id:708519,v:'normalState'},{id:707749,v:'normalState'},{id:708698,v:'normalState'},{id:708705,v:'normalState'},{id:708722,v:'normalState'},{id:708732,v:'normalState'},{id:708742,v:'normalState'},{id:708752,v:'normalState'},{id:708762,v:'normalState'},{id:708777,v:'normalState'},{id:709072,v:'normalState'},{id:709066,v:'normalState'},{id:709886,v:'normalState'},{id:709880,v:'normalState'},{id:710005,v:'normalState'},{id:709999,v:'normalState'},{id:708847,v:'normalState'},{id:710296,v:'normalState'},{id:710303,v:'normalState'},{id:710320,v:'normalState'},{id:710330,v:'normalState'},{id:710340,v:'normalState'},{id:710350,v:'normalState'},{id:710360,v:'normalState'},{id:710375,v:'normalState'},{id:710394,v:'normalState'},{id:710399,v:'normalState'},{id:711464,v:'normalState'},{id:711458,v:'normalState'},{id:711565,v:'normalState'},{id:711559,v:'normalState'},{id:710448,v:'normalState'},{id:689705,v:'normalState'},{id:689723,v:'normalState'},{id:689731,v:'normalState'},{id:696638,v:'normalState'},{id:696644,v:'normalState'},{id:696650,v:'normalState'},{id:696656,v:'normalState'},{id:696903,v:'normalState'},{id:697068,v:'normalState'},{id:697122,v:'normalState'},{id:697176,v:'normalState'},{id:696704,v:'normalState'},{id:697472,v:'normalState'},{id:583647,v:'normalState'},{id:697750,v:'normalState'},{id:697759,v:'normalState'},{id:751762,v:'normalState'},{id:751752,v:'normalState'},{id:751742,v:'normalState'},{id:751732,v:'normalState'},{id:751722,v:'normalState'},{id:751714,v:'normalState'},{id:623233,v:'normalState'},{id:432077,v:'normalState'},{id:574208,v:'normalState'},{id:266279,v:'normalState'},{id:573899,v:'normalState'},{id:574002,v:'normalState'},{id:574459,v:'normalState'},{id:574533,v:'normalState'},{id:574385,v:'normalState'},{id:698233,v:'normalState'},{id:574311,v:'normalState'},{id:558939,v:'normalState'},{id:741706,v:'normalState'},{id:206494,v:'normalState'},{id:307926,v:'normalState'},{id:236052,v:'normalState'},{id:212362,v:'normalState'},{id:207181,v:'normalState'},{id:212319,v:'normalState'},{id:191487,v:'normalState'},{id:323308,v:'normalState'},{id:191575,v:'normalState'},{id:744761,v:'normalState'},{id:105988,v:'normalState'}]};
